#include "ADT_dict.h"

AFun ADT_afun0;
AFun ADT_afun1;
AFun ADT_afun2;

ATerm ADT_patternSeparatorDefault = NULL;
ATerm ADT_patternSeparatorsMany = NULL;
ATerm ADT_patternSeparatorsSingle = NULL;
ATerm ADT_patternSeparatorsEmpty = NULL;
ATerm ADT_patternEntrySeparatedList = NULL;
ATerm ADT_patternEntryList = NULL;
ATerm ADT_patternEntryConstructor = NULL;
ATerm ADT_patternEntriesMany = NULL;
ATerm ADT_patternEntriesSingle = NULL;
ATerm ADT_patternEntriesEmpty = NULL;

/*
 * ADT_afun0 = constructor(x,x,x)
 * ADT_afun1 = list(x,x)
 * ADT_afun2 = separated-list(x,x,x)
 *
 * ADT_patternSeparatorDefault = <term>
 * ADT_patternSeparatorsMany = [<term>,<list>]
 * ADT_patternSeparatorsSingle = [<term>]
 * ADT_patternSeparatorsEmpty = []
 * ADT_patternEntrySeparatedList = separated-list(<term>,<term>,<term>)
 * ADT_patternEntryList = list(<term>,<term>)
 * ADT_patternEntryConstructor = constructor(<term>,<term>,<term>)
 * ADT_patternEntriesMany = [<term>,<list>]
 * ADT_patternEntriesSingle = [<term>]
 * ADT_patternEntriesEmpty = []
 *
 */

static ATerm _ADT_dict = NULL;

#define _ADT_dict_LEN 162

static char _ADT_dict_baf[_ADT_dict_LEN] = {
0x00,0x8B,0xAF,0x83,0x00,0x09,0x1E,0x03,0x3C,0x5F,0x3E,0x01,0x00,0x02,0x02,0x03,
0x04,0x05,0x5B,0x5F,0x2C,0x5F,0x5D,0x02,0x00,0x12,0x06,0x01,0x02,0x00,0x06,0x07,
0x08,0x02,0x01,0x02,0x02,0x5B,0x5D,0x00,0x00,0x01,0x04,0x6C,0x69,0x73,0x74,0x00,
0x00,0x01,0x04,0x74,0x65,0x72,0x6D,0x00,0x00,0x01,0x01,0x78,0x00,0x00,0x01,0x0B,
0x63,0x6F,0x6E,0x73,0x74,0x72,0x75,0x63,0x74,0x6F,0x72,0x03,0x00,0x02,0x02,0x00,
0x05,0x02,0x00,0x05,0x02,0x00,0x05,0x04,0x6C,0x69,0x73,0x74,0x02,0x00,0x02,0x02,
0x00,0x05,0x02,0x00,0x05,0x0E,0x73,0x65,0x70,0x61,0x72,0x61,0x74,0x65,0x64,0x2D,
0x6C,0x69,0x73,0x74,0x03,0x00,0x02,0x02,0x00,0x05,0x02,0x00,0x05,0x02,0x00,0x05,
0x01,0x08,0xC5,0x44,0x09,0x40,0x29,0x54,0x04,0x79,0x10,0xE0,0x44,0x18,0x51,0x16,
0x14,0x44,0x1A,0x1A,0xB0,0x00,0x0A,0x30,0x01,0x2D,0x00,0x00,0x20,0x43,0x82,0x83,
0x25,0x00
};

void init_ADT_dict()
{
  ATermList afuns, terms;

  _ADT_dict = ATreadFromBinaryString(_ADT_dict_baf, _ADT_dict_LEN);

  ATprotect(&_ADT_dict);

  afuns = (ATermList)ATelementAt((ATermList)_ADT_dict, 0);

  ADT_afun0 = ATgetAFun((ATermAppl)ATgetFirst(afuns));
  afuns = ATgetNext(afuns);
  ADT_afun1 = ATgetAFun((ATermAppl)ATgetFirst(afuns));
  afuns = ATgetNext(afuns);
  ADT_afun2 = ATgetAFun((ATermAppl)ATgetFirst(afuns));
  afuns = ATgetNext(afuns);

  terms = (ATermList)ATelementAt((ATermList)_ADT_dict, 1);

  ADT_patternSeparatorDefault = ATgetFirst(terms);
  terms = ATgetNext(terms);
  ADT_patternSeparatorsMany = ATgetFirst(terms);
  terms = ATgetNext(terms);
  ADT_patternSeparatorsSingle = ATgetFirst(terms);
  terms = ATgetNext(terms);
  ADT_patternSeparatorsEmpty = ATgetFirst(terms);
  terms = ATgetNext(terms);
  ADT_patternEntrySeparatedList = ATgetFirst(terms);
  terms = ATgetNext(terms);
  ADT_patternEntryList = ATgetFirst(terms);
  terms = ATgetNext(terms);
  ADT_patternEntryConstructor = ATgetFirst(terms);
  terms = ATgetNext(terms);
  ADT_patternEntriesMany = ATgetFirst(terms);
  terms = ATgetNext(terms);
  ADT_patternEntriesSingle = ATgetFirst(terms);
  terms = ATgetNext(terms);
  ADT_patternEntriesEmpty = ATgetFirst(terms);
  terms = ATgetNext(terms);
}
